﻿'******************************
' アメダスデータコンバータ
'
'  ダウンロードしたアメダスの気象データを変換するプログラムです
'
' [開発者]　Katsuhiro Morishita (Kumamoto-university Japan)
' [開発履歴]
'     2011/9/24   開発開始
'     2012/11/20  ライブラリにしているクラスファイルを更新した。
'     2012/11/23  保存ファイルのフォーマットから、BOMを取り除くようにした。後処理のPythonの処理を簡単にするため。
' *****************************
Imports System.Text.RegularExpressions

Module Module1

    Sub Main()
        Dim i, k As Integer
        Dim t, t2 As Date
        Dim HTMLname, HTMLdir_path, HTMLpath As String
        Dim CSVname, CSVdir_path, CSVpath As String
        Dim target As AmedasSetting = New AmedasSetting
        Dim substrings() As String
        Dim time, outstr, line As String
        Dim hh, mm As Integer
        Dim dhoge As Double
        Dim P, Psea, Temp As String


        If target.IsOpen Then

            t = target.startDate                                                            ' 初日の日付を取得
            While t <= target.stopDate                                                      ' 設定日までループ
                For i = 0 To target.Length - 1                                              ' 指定されたHTMLファイルのパスを生成
                    HTMLdir_path = target.CreateDirectory4rawHTMLs(t, i)                    ' 
                    HTMLname = target.GetFileName4HTML(t, i)                                ' 
                    HTMLpath = HTMLdir_path + "/" + HTMLname
                    CSVdir_path = target.CreateDirectory4processedHTMLs(t, i)               ' 保存用のバス
                    CSVname = target.GetFileName4Process(t, i)
                    CSVpath = CSVdir_path + "/" + CSVname
                    If System.IO.File.Exists(HTMLpath) Then ' HTMLファイルの存在を確認
                        Using sr As New System.IO.StreamReader(HTMLpath, System.Text.Encoding.UTF8)
                            'Using sr As New System.IO.StreamReader(HTMLpath, System.Text.Encoding.GetEncoding("shift_jis"))    ' ファイル出力準備
                            Using sw As New System.IO.StreamWriter(CSVpath, False, New System.Text.UTF8Encoding(False))
                                'Using sw As New System.IO.StreamWriter(CSVpath, False, System.Text.Encoding.GetEncoding("shift_jis"))
                                k = 0                                           ' デバッグコード
                                While sr.EndOfStream = False                    ' 1行づつ処理する
                                    line = sr.ReadLine
                                    k += 1                                      ' デバッグコード
                                    If k >= 91 And k <= 234 Then
                                        ' 正規表現を使って文字列を分割する
                                        substrings = Regex.Split(line, "\<\w+\>|\<\/\w+\>|" +
                                                                 "<td class=""data_0_0"">|" +
                                                                 "<tr class=""mtx"" style=""text-align:right;""><td style=""white-space:nowrap"">|" +
                                                                 "<td class=""data_0_0"" style=""text-align:center"">|" +
                                                                 "<th colspan=""2"">|" +
                                                                 "<th rowspan=""2"">|" +
                                                                 "<th colspan=""4"">")
                                        time = substrings(1)                    ' 時刻を取得
                                        hh = Integer.Parse(time.Split(":")(0))  ' 扱い易い様に数値化
                                        mm = Integer.Parse(time.Split(":")(1))
                                        t2 = t                                  ' 保存ファイル用の時刻オブジェクトを設定
                                        If hh = 24 Then                         ' 24時対策
                                            hh = 0
                                            t2 = t2.AddDays(1)                  ' 24時なら、次の日なので日付を進める
                                        End If
                                        t2 = t2.AddHours(hh).AddMinutes(mm)     ' 時刻を決める
                                        time = t2.ToString
                                        If Double.TryParse(substrings(3), dhoge) = False Then P = "" Else P = dhoge.ToString
                                        If Double.TryParse(substrings(5), dhoge) = False Then Psea = "" Else Psea = dhoge.ToString
                                        If Double.TryParse(substrings(9), dhoge) = False Then Temp = "" Else Temp = dhoge.ToString
                                        If P = "" Then Console.WriteLine(HTMLname + "," + time + ",Pにデータ欠損あり。")
                                        If Psea = "" Then Console.WriteLine(HTMLname + "," + time + ",Pseaにデータ欠損あり。")
                                        If Temp = "" Then Console.WriteLine(HTMLname + "," + time + ",Tempにデータ欠損あり。")
                                        outstr = time + "," + P + "," + Psea + "," + Temp + vbCrLf  ' 書き込み用の文字列を作成
                                        sw.Write(outstr)                        ' ファイルへの書き出し
                                    End If
                                End While
                            End Using
                        End Using
                    Else
                        Console.WriteLine(HTMLpath + "が見つかりません。")
                    End If
                Next
                t = t.AddDays(1)                                                            ' 日付を加算
            End While

        End If
    End Sub

End Module
